/*
    C/C++̃R[h}[NAbvďo͂B
    Shift_JISΉB
    (under modified BSD license)
*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define COPYRIGHT   "Code Marker Version 1.0.1\n" \
                    "Copyright (C) 2005 Yusuke Nojima.\n"

#define USAGE       "g: codemark ̓t@C [ IvV... ]\n" \
                    "IvV:\n" \
                    "  -l                sԍo͂B\n" \
                    "  -t<n>             ^uñXy[XɓWJB\n" \
                    "  -p                pre ^OgpȂB\n" \
                    "  -o <filename>     filenameɏo͂B\n" \
                    "  -h                wv\B\n"

/* G[bZ[W */
#define INPUT_FILE_UNOPENABLE_ERROR     "[ERROR] ̓t@CJ܂łB\n"
#define OUTPUT_FILE_UNOPENABLE_ERROR    "[ERROR] o̓t@CJ܂łB\n"
#define WRONG_T_OPTION_ERROR            "[ERROR] -t̎gԈĂ܂B\n"
#define WRONG_O_OPTION_ERROR            "[ERROR] -o̎gԈĂ܂B\n"
#define NO_INPUT_FILE_ERROR             "[ERROR] ̓t@Cw肳Ă܂B\n"
#define INVALID_TAB_WIDTH_ERROR         "[ERROR] ^uُ̕łB(1n99)\n"
#define UNKNOWN_OPTION_WARNING          "[WARNING] FmłȂIvV𖳎܂B\n"

/* ^O */
#define BEGIN_PRE           "<pre>"
#define END_PRE             "</pre>"
#define BEGIN_CODE          "<code>"
#define END_CODE            "</code>"
#define BEGIN_KEYWORD       "<strong class=\"keyword\">"
#define END_KEYWORD         "</strong>"
#define BEGIN_COMMENT       "<em class=\"comment\">"
#define END_COMMENT         "</em>"
#define BEGIN_STRING        "<em class=\"string\">"
#define END_STRING          "</em>"
#define BEGIN_PREPROCESSOR  "<span class=\"preprocessor\">"
#define END_PREPROCESSOR    "</span>"
#define BEGIN_LINENO        "<span class=\"lineno\">"
#define END_LINENO          "</span>"
#define BREAK_LINE          "<br>"

/* }`oCg^( 1-8 rbgoCg, 9-16 rbgoCg\) */
typedef int MBCHAR;

typedef int BOOL;               /* _^ */
typedef unsigned char UCHAR;    /* Ȃ^ */

#define TRUE    1               /* ^ */
#define FALSE   0               /* U */

#define BUFFER_SIZE     256     /* obt@̃TCY */

/* ch }`oCg̏ꍇ TRUE Ԃ */
#define is_multibyte(ch)    ((ch) & 0x80)
/* }`oCg ch ̑oCgԂ */
#define first_byte(ch)      ((UCHAR)((ch) & 0xff))
/* }`oCg ch ̑oCgԂ */
#define second_byte(ch)     ((UCHAR)((ch) >> 8))

/* C/C++ ̗\ */
const char* keywords[] = {
    "auto", "asm", "bool", "break", "case", "catch", "char", "class",
    "const", "const_cast", "continue", "default", "delete", "do",
    "double", "dynamic_cast", "else", "enum", "explicit", "extern",
    "false", "float", "for", "friend", "goto", "if", "inline", "int",
    "long", "mutable", "namespace", "new", "operator", "private", "protected",
    "public", "register", "reinterpret_cast", "return", "short", "signed",
    "sizeof", "static", "static_cast", "struct", "switch", "template", "this",
    "throw", "true", "try", "typedef", "typeid", "typename", "union",
    "unsigned", "using", "virtual", "void", "volatile", "wchar_t", "while",
    NULL
};


/* O[oϐ */
FILE*   in = NULL;              /* ̓Xg[ */
FILE*   out = NULL;             /* o̓Xg[ */
MBCHAR  ch = '\0';              /* ݓǂݍł镶 */
size_t  line = 1;               /* ݂̍s */
size_t  column = 0;             /* ݂̗ */
size_t  tab_width = 4;          /* ^u̕ */
BOOL    nopre = FALSE;              /* pre ^OgpȂꍇ TRUE */
BOOL    generate_lineno = FALSE;    /* sԍ𐶐ꍇ TRUE */


/* ̕擾 */
MBCHAR get_char(void)
{
    MBCHAR ch = fgetc(in);
    if ((ch & 0x80) && (ch != EOF))
        ch = (ch | (fgetc(in) << 8));
    return ch;
}


/* s̎n܂̏ */
void on_begin_line(void)
{
    if (generate_lineno) {      /* sԍo */
        size_t i;

        fputs(BEGIN_LINENO, out);
        for (i = 100; i >= 1; i /= 10) {
            if (line >= i) {
                fprintf(out, "%d", line);
                break;
            } else {
                if (nopre)
                    fputs("&nbsp;", out);
                else
                    fputc(' ', out);
            }
        }
        fputs(": " END_LINENO, out);
    }
}


/* ch o͂ */
void output_char(MBCHAR ch)
{
    size_t n;

    switch (ch) {
    case ' ':
        if (nopre) {
            fputs("&nbsp;", out);
        } else {
            fputc(' ', out);
        }
        break;
    case '&':
        fputs("&amp;", out);
        break;
    case '<':
        fputs("&lt;", out);
        break;
    case '>':
        fputs("&gt;", out);
        break;
    case '\t':
        n = tab_width - column % tab_width;
        while (n--)
            output_char(' ');
        --column;
        break;
    case '\n':
        if (nopre) {
            fputs(BREAK_LINE "\n", out);
        } else {
            fputc('\n', out);
        }
        line += 1;
        column = -1;
        on_begin_line();
        break;
    default:
        if (is_multibyte(ch)) {
            fputc(first_byte(ch), out);
            fputc(second_byte(ch), out);
        } else {
            fputc(ch, out);
        }
        break;
    }
    ++column;
}


/* str o͂(}`oCg) */
void output(const char* str)
{
    for (; *str != '\0'; ++str)
        output_char((MBCHAR)*str);
}


/* str \̏ꍇ TRUE AłȂꍇ FLASE Ԃ */
BOOL is_keyword(const char* str)
{
    const char** p;

    for (p = keywords; *p != NULL; ++p)
        if (strcmp(*p, str) == 0)
            return TRUE;

    return FALSE;
}


/* ʎq܂͗\}[NAbvďo͂ */
void markup_identifier(void)
{
    char buffer[BUFFER_SIZE];
    int i = 0;

    while ((isalnum(first_byte(ch)) || ch == '_') && i < BUFFER_SIZE) {
        buffer[i] = ch;     /* ch ͔p̂͂ */
        ch = get_char();
        ++i;
    }

    buffer[i] = '\0';

    if (is_keyword(buffer)) {
        fputs(BEGIN_KEYWORD, out);
        output(buffer);
        fputs(END_KEYWORD, out);
    } else {
        output(buffer);
    }
}


/* sRg}[NAbvďo͂ */
void markup_multiline_comment(void)
{
    MBCHAR prev_ch = '\0';  /* O̕ */

    fputs(BEGIN_COMMENT, out);
    output("/*");

    while ((ch = get_char()) != EOF) {
        output_char(ch);
        if (prev_ch == '*' && ch == '/')
            break;
        prev_ch = ch;
    }

    fputs(END_COMMENT, out);
    ch = get_char();
}


/* sRg}[NAbvďo͂ */
void markup_line_comment(void)
{
    MBCHAR prev_ch = '\0';  /* O̕ */

    fputs(BEGIN_COMMENT, out);
    output("//");

    while ((ch = get_char()) != EOF) {
        output_char(ch);
        if (ch == '\n' && prev_ch != '\\')
            break;
        prev_ch = ch;
    }

    fputs(END_COMMENT, out);
    ch = get_char();
}


/* }[NAbvďo͂ */
void markup_string(void)
{
    MBCHAR quote = ch;      /* Ήp */
    BOOL escaped = FALSE;   /* GXP[vĂ邩 */

    fputs(BEGIN_STRING, out);
    output_char(ch);

    while ((ch = get_char()) != EOF) {
        output_char(ch);
        if (ch == quote && !escaped)
            break;
        if (ch == '\\' && !escaped)
            escaped = TRUE;
        else
            escaped = FALSE;
    }

    fputs(END_STRING, out);
    ch = get_char();
}


/* vvZbT}[NAbvďo */
void markup_preprocessor(void)
{
    MBCHAR prev_ch = '\0';  /* O̕ */

    fputs(BEGIN_PREPROCESSOR, out);
    output_char(ch);

    while ((ch = get_char()) != EOF) {
        while (ch == '/') {     /* Rg? */
            ch = get_char();
            if (ch == '*')
                markup_multiline_comment();
            else if (ch == '/')
                markup_line_comment();
            else
                output_char('/');
        }
        output_char(ch);
        if (ch == '\n' && prev_ch != '\\')
            break;
        prev_ch = ch;
    }

    fputs(END_PREPROCESSOR, out);
    ch = get_char();
}


/* }[NAbv */
void markup(void)
{
    if (!nopre)
        fputs(BEGIN_PRE, out);

    fputs(BEGIN_CODE, out);
    on_begin_line();
    ch = get_char();

    while (ch != EOF) {
        if (isalpha(first_byte(ch)) || ch == '_') {
            /* ʎq or \ */
            markup_identifier();
        } else if (ch == '"' || ch == '\'') {
            /*  */
            markup_string();
        } else if (ch == '/') {
            /* Rg? */
            switch (ch = get_char()) {
            case '*':
                /* sRg */
                markup_multiline_comment();
                break;
            case '/':
                /* sRg */
                markup_line_comment();
                break;
            default:
                /* RgȂ̂ł̂܂܏o */
                output_char('/');
                break;
            }
        } else if (ch == '#') {
            /* vvZbT */
            markup_preprocessor();
        } else {
            /* Xy[XƂAZqƂ͂̂܂܏o */
            output_char(ch);
            ch = get_char();
        }
    }
    fputs(END_CODE, out);
    if (!nopre)
        fputs(END_PRE, out);
}


/* p[X */
BOOL parse_arguments(int argc, char* argv[])
{
    int i;
    BOOL output_file = FALSE;   /* ̈o̓t@C̏ꍇATRUE */

    for (i = 1; i < argc; ++i) {
        if (argv[i][0] != '-') {    /* ̓t@C or o̓t@C(-o) */
            if (output_file) {
                if (out)
                    fclose(out);
                out = fopen(argv[i], "w");
                if (out == NULL) {
                    fputs(OUTPUT_FILE_UNOPENABLE_ERROR, stderr);
                    return FALSE;
                }
                output_file = FALSE;
            } else {
                if (in)
                    fclose(in);
                in = fopen(argv[i], "r");
                if (in == NULL) {
                    fputs(INPUT_FILE_UNOPENABLE_ERROR, stderr);
                    return FALSE;
                }
            }
        } else {    /* IvV */
            if (output_file) {
                fputs(WRONG_O_OPTION_ERROR, stderr);
                return FALSE;
            }
            switch (argv[i][1]) {
            case 'l':   /* -l sԍ */
            case 'L':
                generate_lineno = TRUE;
                break;
            case 'p':   /* -p pre ^OgpȂ */
            case 'P':
                nopre = TRUE;
                break;
            case 't':   /* -t<n> ^unɐݒ */
            case 'T':
                if (sscanf(&argv[i][2], "%u", &tab_width) < 1) {
                    fputs(WRONG_T_OPTION_ERROR, stderr);
                    return FALSE;
                }
                if (tab_width - 1 >= 99) {
                    fputs(INVALID_TAB_WIDTH_ERROR, stderr);
                    return FALSE;
                }
                break;
            case 'o':   /* -o <filename> filenameɏo */
            case 'O':
                output_file = TRUE;
                break;
            case 'h':   /* -h wv\ */
            case 'H':
                fputs(COPYRIGHT "\n" USAGE, stderr);
                return FALSE;
            default:    /* sȃIvV */
                fputs(UNKNOWN_OPTION_WARNING, stderr);
                break;
            }
        }
    }
    if (in == NULL) {
        fputs(NO_INPUT_FILE_ERROR "\n" USAGE, stderr);
        return FALSE;
    }
    if (out == NULL)
        out = stdout;
    return TRUE;
}


/* C֐ */
int main(int argc, char* argv[])
{
    if (!parse_arguments(argc, argv))
        return 1;
    markup();
    fclose(in);
    fclose(out);
    return 0;
}
